﻿using System;
using System.Net.Sockets;
using System.Text;
using System.Windows;

/*
 *         Progetto: Software Client/Server per l'invio di messaggi
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 15/10/2015
 *  
 *      Descrizione: Modulo client - Invia al server una stringa 
 *                   utilizzando la classe TcpClient.
 */

namespace Client
{
    /// <summary>
    /// Logica di interazione per MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        const string indirizzoServer = "10.0.2.5"; //"localhost";
        const int portaServer = 3289;
        public MainWindow()
        {
            InitializeComponent();
        }

        private async void InviaMessaggio(string msg, string autore)
        {
            try
            {
                using (var client = new TcpClient())
                {
                    await client.ConnectAsync(indirizzoServer, portaServer);
                    using (NetworkStream ns = client.GetStream())
                    {
                        string s = String.Format("{0} ({1})", msg, autore);
                        byte[] buffer = Encoding.UTF8.GetBytes(s);

                        await ns.WriteAsync(buffer, 0, buffer.Length);
                    }
                }
                MessageBox.Show("Messaggio inviato correttamente.", "Risultato", MessageBoxButton.OK, 
                    MessageBoxImage.Information);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message, "Errore nell'invio", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void btnInvia_Click(object sender, RoutedEventArgs e)
        {
            InviaMessaggio(boxMessaggio.Text, boxNome.Text);
        }
    }
}
