﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Windows;
using System.Windows.Controls;

/*
 *         Progetto: Software Client/Server per l'invio di messaggi
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 15/10/2015
 *  
 *      Descrizione: Modulo server - Riceve e mostra i messaggi testuali 
 *                   inviati dai client. Usa la classe TcpListener.
 */

namespace Server
{
    /// <summary>
    /// Logica di interazione per MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        const int PortaServer = 3289;   // TCP


        public MainWindow()
        {
            InitializeComponent();
        }

        private async void AvviaListener()
        {
            TcpListener listener = new TcpListener(IPAddress.Any, PortaServer);
            listener.Start(30);

            while (true)
            {
                TcpClient client = await listener.AcceptTcpClientAsync();

                using (NetworkStream networkStream = client.GetStream())
                {
                    byte[] buffer = new byte[4096];
                    int numByte = await networkStream.ReadAsync(buffer, 0, buffer.Length);
                    string m = Encoding.UTF8.GetString(buffer, 0, numByte);

                    MostraMessaggio(m);
                }
            }
        }

        private void MostraMessaggio(string msg)
        {
            ListBoxItem i = new ListBoxItem();
            i.Content = String.Format("{0:HH:mm:ss} - {1}", DateTime.Now, msg);
            elenco.Items.Insert(0, i);
        }


        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            AvviaListener();
        }
    }
}
